import * as react from 'react';
import { R as ReactParamsObject } from '../../types-f70a2cb5.js';
import * as international_types from 'international-types';
import { ImportedLocales, ExplicitLocales, GetLocaleType } from 'international-types';

declare function createI18nServer<Locales extends ImportedLocales, OtherLocales extends ExplicitLocales | null = null>(locales: Locales): {
    getI18n: () => Promise<{
        <Key extends Extract<keyof (OtherLocales extends ExplicitLocales ? GetLocaleType<OtherLocales> : GetLocaleType<Locales>), string>, Value extends international_types.LocaleValue = (OtherLocales extends ExplicitLocales ? GetLocaleType<OtherLocales> : GetLocaleType<Locales>)[Key]>(key: Key, ...params: international_types.Params<Value>["length"] extends 0 ? [] : [international_types.ParamsObject<Value>]): string;
        <Key_1 extends Extract<keyof (OtherLocales extends ExplicitLocales ? GetLocaleType<OtherLocales> : GetLocaleType<Locales>), string>, Value_1 extends international_types.LocaleValue = (OtherLocales extends ExplicitLocales ? GetLocaleType<OtherLocales> : GetLocaleType<Locales>)[Key_1]>(key: Key_1, ...params: international_types.Params<Value_1>["length"] extends 0 ? [] : [ReactParamsObject<Value_1>]): react.ReactNode;
    }>;
    getScopedI18n: <Scope extends international_types.Scopes<OtherLocales extends ExplicitLocales ? GetLocaleType<OtherLocales> : GetLocaleType<Locales>>>(scope: Scope) => Promise<{
        <Key_2 extends international_types.LocaleKeys<OtherLocales extends ExplicitLocales ? GetLocaleType<OtherLocales> : GetLocaleType<Locales>, Scope, Extract<keyof (OtherLocales extends ExplicitLocales ? GetLocaleType<OtherLocales> : GetLocaleType<Locales>), string>>, Value_2 extends international_types.LocaleValue = international_types.ScopedValue<OtherLocales extends ExplicitLocales ? GetLocaleType<OtherLocales> : GetLocaleType<Locales>, Scope, Key_2>>(key: Key_2, ...params: international_types.Params<Value_2>["length"] extends 0 ? [] : [international_types.ParamsObject<Value_2>]): string;
        <Key_3 extends international_types.LocaleKeys<OtherLocales extends ExplicitLocales ? GetLocaleType<OtherLocales> : GetLocaleType<Locales>, Scope, Extract<keyof (OtherLocales extends ExplicitLocales ? GetLocaleType<OtherLocales> : GetLocaleType<Locales>), string>>, Value_3 extends international_types.LocaleValue = international_types.ScopedValue<OtherLocales extends ExplicitLocales ? GetLocaleType<OtherLocales> : GetLocaleType<Locales>, Scope, Key_3>>(key: Key_3, ...params: international_types.Params<Value_3>["length"] extends 0 ? [] : [ReactParamsObject<Value_3>]): react.ReactNode;
    }>;
    getCurrentLocale: () => OtherLocales extends ExplicitLocales ? keyof OtherLocales : keyof Locales;
    getStaticParams: () => {
        locale: string;
    }[];
};

export { createI18nServer };
